// PointVector.h: interface for the PointVector class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_POINTVECTOR_H__567B768E_ABA6_40C4_B3C2_AE6BA354647C__INCLUDED_)
#define AFX_POINTVECTOR_H__567B768E_ABA6_40C4_B3C2_AE6BA354647C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <math.h>

class PointVector  
{
public:
	PointVector Add(PointVector other);
	PointVector ProjectToXZ();
	bool Equals(PointVector other);
	bool operator==(const PointVector& somepv);
	bool ZIsZero();
	bool XIsZero();
	void Reset();
	float Length();
	void Reverse();
	void Print();
	float DistanceBetweenPoint(PointVector p2);
	void SetXYZ(PointVector xyzPosition);
	void Add(float xadd,float yadd,float zadd);
	void SetXYZ(float x,float y,float z);
	PointVector SubtractVector(PointVector vectorToSubtract);
	void MultiplyScalar(float scalar);
	// constructors, destructor, operators
	PointVector(const PointVector& pv);
	PointVector();
	PointVector(float x,float y,float z);
	const PointVector& operator=(const PointVector& somepv);
	virtual ~PointVector();
	// accessors and mutators
	float GetZ();
	float GetY();
	float GetX();
	void SetZ(float z);
	void SetY(float y);
	void SetX(float x);
	// operations
	float DotProduct(PointVector v2);
	void MultiplyMatrix(float *matrix);
	void Normalize();
	PointVector CreateVector(PointVector p2);
	PointVector CrossProduct(PointVector v2);
	PointVector NormalizedCrossProduct(PointVector p2);

private:
	float xvalue;	// x vector component or point position
	float yvalue;	// y vector component or point position
	float zvalue;	// z vector component or point position
};

#endif // !defined(AFX_POINTVECTOR_H__567B768E_ABA6_40C4_B3C2_AE6BA354647C__INCLUDED_)
