#include "PointVector.h"
// WorldObject.h: interface for the WorldObject class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WORLDOBJECT_H__52F588F8_8226_420D_A162_C4E18D73682A__INCLUDED_)
#define AFX_WORLDOBJECT_H__52F588F8_8226_420D_A162_C4E18D73682A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class WorldObject  
{
public:
	bool BelowGround();
	void SphereCollisionRoutine(WorldObject otherObject,float elasticity);
	float GroundCollisionRoutine(float elasticity);
	void MoveAboveGround();
	bool GroundCollision();
	PointVector ReflectOffGround(float elasticity);
	float GetSize();
	int GetID();
	void SetID(int id);
	void ResetSpeed();
	void ResetSpeedPosition();
	void Move(PointVector distance);
	void MoveOutOf(WorldObject obj);
	void SetMass(float objectmass);
	void Print();
	PointVector ReflectOffObject(WorldObject otherObject,float elasticity);
	const WorldObject& operator =(const WorldObject &someObject);
	void SetSize(float setsize);
	bool SphereCollision(WorldObject anotherObject);
	PointVector GetVelocity();
	PointVector GetPosition();
	void SetVelocity(PointVector vel);
	void Move();
	void Accelerate(PointVector accelerationVector);
	void SetPosition(PointVector pos);
	WorldObject(PointVector pos,float objectmass,float objectsize);
	WorldObject(const WorldObject& anotherobject);
	WorldObject();
	virtual ~WorldObject();
private:
	PointVector position;
	PointVector velocity;
	float mass;
	float size;
	int idnumber;
};

#endif // !defined(AFX_WORLDOBJECT_H__52F588F8_8226_420D_A162_C4E18D73682A__INCLUDED_)
