#include "p3.h"
#include <stdlib.h>
#include <stdio.h>
#include <iostream>

int main( int argc, char *argv[] )
{
	InitData();
	InitCameraData();
	glutInit( &argc, argv );
	glutInitWindowPosition(200,200);
	glutInitWindowSize(windowWidth,windowHeight);
	glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH | GLUT_STENCIL );
	glutCreateWindow("Snow Fight");
	   
	/* GLUT callbacks */
	glutReshapeFunc(ChangeSize);
	glutKeyboardFunc(NormalKeys);
	glutSpecialFunc(SpecialKeys);
	glutMouseFunc(Mouse);
	glutMotionFunc(ActiveMouseMotion);
	glutDisplayFunc(RenderScene);
	glutIdleFunc(RenderScene);
	
	/* initialize other data */
	InitWorldData(1);
	InitSphereData();
	//InitFog();
	InitGL();
	glutMainLoop();
	return 0;
}
/*
void UpdateFps()
{
	frame++;
	time=glutGet(GLUT_ELAPSED_TIME);
	
	if (time - timebase > 1000) 
	{
		fps = frame*1000.0/(time - timebase);
	 	timebase = time;		
		frame = 0;
		//printf("Framerate: %d\n",fps);
	}
}
*/
void InitTextures()
{
	texList = new unsigned int[5];
	glGenTextures(5, texList);

	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	unsigned int w1, h1, components1;  image1 =
	loadPNM("igloo.ppm",w1,h1,components1);
	glBindTexture(GL_TEXTURE_2D, texList[0]);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
	gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, w1, h1, GL_RGB, GL_UNSIGNED_BYTE, image1);

	unsigned int w2, h2, components2;  image2 =
	loadPNM("snow.ppm",w2,h2,components2);
	glBindTexture(GL_TEXTURE_2D, texList[1]);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
	gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, w2, h2, GL_RGB, GL_UNSIGNED_BYTE, image2);

	unsigned int w3, h3, components3;  image3 =
	loadPNM("winter.ppm",w3,h3,components3);
	glBindTexture(GL_TEXTURE_2D, texList[2]);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
	gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, w3, h3, GL_RGB, GL_UNSIGNED_BYTE, image3);

	unsigned int w4, h4, components4;  image4 =
	loadPNM("ice.ppm",w4,h4,components4);
	glBindTexture(GL_TEXTURE_2D, texList[3]);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
	gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, w4, h4, GL_RGB, GL_UNSIGNED_BYTE, image4);
	
	unsigned int w5, h5, components5;  image5 =
	loadPNM("lava.ppm",w5,h5,components5);
	glBindTexture(GL_TEXTURE_2D, texList[4]);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
	gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, w5, h5, GL_RGB, GL_UNSIGNED_BYTE, image5);
}

void InitSphereData()
{
	spherelist = NULL;
	staticspherelist = NULL;
	enemylist = NULL;
}

void InitData()
{
	windowWidth = 640;
	windowHeight = 480;

	// screen ratio
	ratio = 0.0;

	// fps
	/*
	frame = 0;
	time = 0;
	timebase = 0;
	fpstoggle = false;
	*/

	// picking data
	hits = 0;
}

void InitCameraData()
{
	// initialize camera movement data
	cameraData.pitchAngle = 0.0;
	cameraData.yawAngle = 0.0;
	
	// camera vectors
	cameraPosition.SetX(0.0);
	cameraPosition.SetY(10.0);
	cameraPosition.SetZ(-50.0);
	cameraViewVector.SetX(0.0);
	cameraViewVector.SetY(0.0);
	cameraViewVector.SetZ(1.0);
	cameraUpVector.SetX(0.0);
	cameraUpVector.SetY(1.0);
	cameraUpVector.SetZ(0.0);
	cameraSideVector.SetX(1.0);
	cameraSideVector.SetY(0.0);
	cameraSideVector.SetZ(0.0);
}

void InitWorldData(int level)
{
	// player score
	score = 0;
	// snowball throwing data
	snowballcounter = 0;
	maxsnowballcount = 20;
	throwstrength = 1.0;
	snowballmass = 1.0;
	snowballsize = 1.0;
	maxgroundbounce = 20;
	snowballdetail = 10;
		
	// world variables
	// gravity
	PointVector gravity = PointVector(0.0,-0.01,0.0);
	worldGravity.SetXYZ(gravity);
	PointVector snowgravity = PointVector(0.0,-0.001,0.0);
	snowGravity.SetXYZ(snowgravity);
	// size
	worldwidth = 100.0;
	worldlength = 100.0;
	worldheight = 100.0;
	
	// enemies
	enemyheight = 50.0;
	enemymass = 2.0;
	enemysize = 10.0;
	numberenemies = level * 3;
	enemydetail = 20;
	enemylife = 1;
	
	// camera
	cameraMode = PLAYERMODE;
	cameraStop = true;
	InitSnowFallData();
}

void InitSnowFallData()
{
	// snowfall
	snowdensity = 1;						// approximately 1 snow flake per unit cubed
	tickvalue = SolveSnowTick(snowdensity,snowGravity);
	tickcounter = 0;
	snowmelt = false;
}

int SolveSnowTick(int density,PointVector gravityVector)
{
	float value = 1.0 / ((float) density);
	value = (value * 2.0) / -gravityVector.GetY();
	float returnvalue = sqrt(value);
	return (int) returnvalue;
}

void SnowRoutine()
{
	if(tickcounter >= tickvalue)
	{
		GenerateRandomSnow(rand()%((int) worldwidth));
		tickcounter = 0;
	}
	else
	{
		tickcounter++;
	}
}

void DestroyData()
{

	delete [] texList;
	delete image1;
	delete image2;
	delete image3;
	delete image4;
	delete image5;

}

int InitGL(GLvoid)										// All Setup For OpenGL Goes Here
{
	InitData();
	InitTextures();
	glShadeModel(GL_SMOOTH);							// Enable Smooth Shading
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
	glClearDepth(1.0f);									// Depth Buffer Setup
	glClearStencil(0);									// Clear The Stencil Buffer To 0
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculations
	glEnable(GL_TEXTURE_2D);							// Enable 2D Texture Mapping

	glLightfv(GL_LIGHT0, GL_AMBIENT, LightAmb);			// Set The Ambient Lighting For Light0
	glLightfv(GL_LIGHT0, GL_DIFFUSE, LightDif);			// Set The Diffuse Lighting For Light0
	glLightfv(GL_LIGHT0, GL_POSITION, LightPos);		// Set The Position For Light0

	glEnable(GL_LIGHT0);								// Enable Light 0
	glEnable(GL_LIGHTING);								// Enable Lighting

	glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);	// Set Up Sphere Mapping
	glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);	// Set Up Sphere Mapping

	return true;										// Initialization Went OK
}

void ActiveMouseMotion(int x,int y)
{
  // left mouse controls speed and yaw
  if(mouseCoords.leftMouseDown)
    {
      mouseCoords.differenceX = x - mouseCoords.x;
      mouseCoords.differenceY = y - mouseCoords.y;
      if(mouseCoords.differenceX)
	{
	  cameraData.rollAngle = (float) mouseCoords.differenceX / 100.0;
	  mouseCoords.moved = true;
	}
      if(mouseCoords.differenceY)
	{
	  cameraData.speed = (float) mouseCoords.differenceY / -100.0;
	  mouseCoords.moved = true;
	}
    }
  if(mouseCoords.rightMouseDown)
    {
      mouseCoords.differenceX = x - mouseCoords.x;
      mouseCoords.differenceY = y - mouseCoords.y;
      if(mouseCoords.differenceX)
	{
	  cameraData.yawAngle = (float) mouseCoords.differenceX / 100.0;
	  mouseCoords.moved = true;
	}
      if(mouseCoords.differenceX)
	{
	  cameraData.pitchAngle = (float) mouseCoords.differenceY / 100.0;
	  mouseCoords.moved = true;
	}
    }
}

void ChangeSize(int w, int h)
{
	// Prevent a divide by zero, when window is too short
	// (you cant make a window of zero newwidth).
	if(h == 0)
		h = 1;

	ratio = 1.0f * w / h;
	// Reset the coordinate system before modifying
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	
	// Set the viewport to be the entire window
   	glViewport(0, 0, w, h);

	// Set the clipping volume
	gluPerspective(60.0,ratio,0.1,500.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	if(cameraMode == FREEFLYMODE)
	{
		gluLookAt(	cameraPosition.GetX(), cameraPosition.GetY(), cameraPosition.GetZ(),
			cameraPosition.GetX() + cameraViewVector.GetX(), cameraPosition.GetY() + cameraViewVector.GetY(), cameraPosition.GetZ() + cameraViewVector.GetZ(),
			cameraUpVector.GetX(), cameraUpVector.GetY(), cameraUpVector.GetZ() );
	}
	else if(cameraMode == PLAYERMODE)
	{	
		gluLookAt(	cameraPosition.GetX(), cameraPosition.GetY(), cameraPosition.GetZ(),
				cameraPosition.GetX() + cameraViewVector.GetX(), cameraPosition.GetY() + cameraViewVector.GetY(), cameraPosition.GetZ() + cameraViewVector.GetZ(),
				0.0,1.0,0.0 );
	}
}

void SpecialKeys(int key, int x, int y) {

	switch (key) {
	case GLUT_KEY_LEFT:
		cameraData.yawAngle = -1;
		mouseCoords.moved = true;
		break;
	case GLUT_KEY_RIGHT:
		cameraData.yawAngle = 1;
		mouseCoords.moved = true;
		break;
	case GLUT_KEY_UP:
		cameraData.pitchAngle = 1;
		mouseCoords.moved = true;
		break;
	case GLUT_KEY_DOWN:
		cameraData.pitchAngle = -1;
		mouseCoords.moved = true;
		break;
	}
}

void PositionCamera()
{
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(60.0,ratio,0.1,500.0);

	glMatrixMode(GL_MODELVIEW);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// clear buffers + stencil

	if(mode == SELECT)
		StartPicking();

	// first load and store identity matrix
	if(mouseCoords.pitchPressed)
	{
		glLoadIdentity();
		// calculate new arbitrary cameraSideVector to pitch about
		cameraSideVector = cameraUpVector.NormalizedCrossProduct(cameraViewVector);
		// rotate about cameraSideVector
		glRotatef(cameraData.pitchAngle,cameraSideVector.GetX(),cameraSideVector.GetY(),cameraSideVector.GetZ());
		// store the matrix
		glGetFloatv(GL_MODELVIEW_MATRIX,pitchRotateMatrix);
		// update cameraUp and cameraView vectors
		RotateCameraPitch(pitchRotateMatrix);
	}
	if(mouseCoords.yawPressed)
	{
		glLoadIdentity();
		// rotate about cameraUp vector
		glRotatef(cameraData.yawAngle,cameraUpVector.GetX(),cameraUpVector.GetY(),cameraUpVector.GetZ());
		// store the matrix
		glGetFloatv(GL_MODELVIEW_MATRIX,yawRotateMatrix);
		// update cameraView vector
		RotateCameraYaw(yawRotateMatrix);
	}
	if(mouseCoords.rollPressed && cameraMode == FREEFLYMODE)	// only roll when in free fly mode
	{
		glLoadIdentity();
		// rotate about cameraView vector
		glRotatef(cameraData.rollAngle,cameraViewVector.GetX(),cameraViewVector.GetY(),cameraViewVector.GetZ());
		// store the matrix
		glGetFloatv(GL_MODELVIEW_MATRIX,rollRotateMatrix);
		// update cameraUp vector
		RotateCameraRoll(rollRotateMatrix);
	}
	if(mouseCoords.movePressed)
	{
	    MoveCamera(cameraData.speed);
	}

	glLoadIdentity();
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	if(cameraMode == FREEFLYMODE)
	{
		gluLookAt(	cameraPosition.GetX(), cameraPosition.GetY(), cameraPosition.GetZ(),
			cameraPosition.GetX() + cameraViewVector.GetX(), cameraPosition.GetY() + cameraViewVector.GetY(), cameraPosition.GetZ() + cameraViewVector.GetZ(),
			cameraUpVector.GetX(), cameraUpVector.GetY(), cameraUpVector.GetZ() );
	}
	else if(cameraMode == PLAYERMODE)
	{	
		gluLookAt(	cameraPosition.GetX(), cameraPosition.GetY(), cameraPosition.GetZ(),
				cameraPosition.GetX() + cameraViewVector.GetX(), cameraPosition.GetY() + cameraViewVector.GetY(), cameraPosition.GetZ() + cameraViewVector.GetZ(),
				0.0,1.0,0.0 );
	}
}

bool ObjectOutOfBounds(WorldObject object)
{
	PointVector objectPosition = object.GetPosition();
	if(objectPosition.GetX() < -worldwidth || objectPosition.GetX() > worldwidth)
	{
	//	printf("Object out of bounds\n");
		return true;
	}
	if(objectPosition.GetZ() < -worldlength || objectPosition.GetZ() > worldlength)
	{
	//	printf("Object out of bounds\n");
		return true;
	}

	//printf("Object not out of bounds\n");	
	return false;	
}

bool SphereWillBeOutOfBounds(PointVector sphereposition,float size)
{
	float xposition = sphereposition.GetX();
	float yposition = sphereposition.GetY();
	float zposition = sphereposition.GetZ();
	if((xposition - size) < -worldwidth || (xposition + size) > worldwidth)
	{
		return true;
	}
	if((zposition - size) < -worldlength || (zposition + size) > worldlength)
	{
		return true;
	}
	if((yposition - size) < 0.0 || (yposition + size) > worldheight)
	{
		return true;
	}
	return false;
}

void StartPicking() 
{
	GLint viewport[4];
	float ratio;

	glSelectBuffer(BUFSIZE,selectBuf);

	glGetIntegerv(GL_VIEWPORT,viewport);

	glRenderMode(GL_SELECT);

	glInitNames();

	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();

	gluPickMatrix(mouseCursorX,viewport[3]-mouseCursorY,1,1,viewport);
	ratio = (viewport[2]+0.0) / viewport[3];
	gluPerspective(60.0,ratio,0.1,500.0);
	glMatrixMode(GL_MODELVIEW);
}

void StopPicking() {
	// revert back to original matrices
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
	glFlush();
	// start processing the hit list
	hits = glRenderMode(GL_RENDER);
	if (hits != 0){
		// store cube and its face picked 
		ProcessHits(hits,selectBuf,0);
//		int pickedCube = cubeFace[0];
	}
//	printf("There are %d hits\n",hits);
	mode = RENDER;
}

void GenerateRandomEnemies(int number)
{
	quadricNode* addEnemy = NULL;
	// generate number of enemies spaced out within volume
	for(int i = 0;i < number;i++)
	{
		int doublewidth = 2 * (int) worldwidth;
		int doublelength = 2 * (int) worldlength;
		float xposition = rand() % doublewidth;
		float yposition = enemyheight;
		float zposition = rand() % doublelength;
		xposition -= worldwidth;
		zposition -= worldlength;
		PointVector pos = PointVector(xposition,yposition,zposition);
		// keep generating new numbers if find enemy overlap and sphere will be out of bounds
		while(FindEnemyOverlap(enemylist,pos) || SphereWillBeOutOfBounds(pos,enemysize))
		{
			xposition = rand() % doublewidth;
			xposition -= worldwidth;
			zposition = rand() % doublelength;
			zposition -= worldlength;
			pos.SetX(xposition);
			pos.SetZ(zposition);	
		}
		// once reached here means no over lap just add to list
		WorldObject enemyObject = WorldObject(pos,enemymass,enemysize);
		enemylist = AddToQuadricList(enemylist,ENEMIES,enemyObject,FIRE,WINTER);
	}
}

void GenerateRandomSnow(int number)
{
	pointNode* addSnowflake = NULL;
	// generate number of snowflakes spaced out within volume
	for(int i = 0;i < number;i++)
	{
		int doublewidth = 2 * (int) worldwidth;
		int doublelength = 2 * (int) worldlength;
		float xposition = rand() % doublewidth;
		float yposition = worldheight;
		float zposition = rand() % doublelength;
		xposition -= worldwidth;
		zposition -= worldlength;
		// don't have to check if out of bounds since snow has no size
		// add to snow list
		// generate random size
		float randomsize = (float) (rand() % 5);
		PointVector pos = PointVector(xposition,yposition,zposition);
		WorldObject snowflake = WorldObject(pos,0.0,randomsize);
		snowlist = AddToPointList(snowlist,snowflake);	
	}
	
}

bool FindEnemyOverlap(quadricNode* list,PointVector position)
{
	// loop over entire list and find overlap in position, if overlap return true else return false
	if(list != NULL)
	{
		// if list not empty we traverse it and compare postions
		while(list != NULL)
		{
			PointVector objectPosition = (*list).objectDescription.GetPosition();	// extact position vector of object
			if(position.DistanceBetweenPoint(objectPosition) < 2*enemysize)
			{
				return true;
			}
			// move to next in the list
			list = (*list).next;
		}
		return false;
	}
	return false;
}

void DrawReflectionObjects()
{
	// Clipping Plane Equation
	double eqr[] = {0.0f,0.0f, 0.0f, 0.0f};			

	glColorMask(0,0,0,0);								// 
	glEnable(GL_STENCIL_TEST);							// 
	glStencilFunc(GL_ALWAYS, 1, 1);						// 
	glStencilOp(GL_KEEP, GL_KEEP, GL_REPLACE);			// 
														// 
														// 
	glDisable(GL_DEPTH_TEST);							// 
	DrawFloor(worldwidth,worldlength);					// 
														// 
	glEnable(GL_DEPTH_TEST);							// 
	glColorMask(1,1,1,1);								// 
	glStencilFunc(GL_EQUAL, 1, 1);						// 
														// 
	glStencilOp(GL_KEEP, GL_KEEP, GL_KEEP);				// 
	glEnable(GL_CLIP_PLANE0);							// 
														// 
	glClipPlane(GL_CLIP_PLANE0, eqr);					// 
	glPushMatrix();										// 
	glScalef(1.0f, -1.0f, 1.0f);						// Mirror Y Axis and draw again
	glLightfv(GL_LIGHT0, GL_POSITION, LightPos);		// 
//////////////////////////////////////////////////////////
	pushnames = false;
	TraverseDraw(spherelist,SNOWBALLS,snowballdetail);
	TraverseDraw(enemylist,ENEMIES,enemydetail);
	TraverseDrawPoints(snowlist);

//////////////////////////////////////////////////////////
	glPopMatrix();										// 
	glDisable(GL_CLIP_PLANE0);							// 
	glDisable(GL_STENCIL_TEST);							// 
	glLightfv(GL_LIGHT0, GL_POSITION, LightPos);		// 
	glEnable(GL_BLEND);									// 
	glDisable(GL_LIGHTING);								// 
	glColor4f(1.0f, 1.0f, 1.0f, 0.8f);					// 
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);	// 
	DrawFloor(worldwidth,worldlength);					// 
	glEnable(GL_LIGHTING);								// 
	glDisable(GL_BLEND);// Disable Blending			    //
//////////////////////////////////////////////////////////
	pushnames = true;
	TraverseDraw(spherelist,SNOWBALLS,snowballdetail);
	pushnames = false;
	TraverseDraw(enemylist,ENEMIES,enemydetail);
	TraverseDrawPoints(snowlist);
}

void DrawMoon()
{
	// Top triangle portion
	glBegin(GL_TRIANGLES);
	glNormal3f(0.0,0.0,1.0);
	glVertex3f(-1.5,1.0,0.0);
	glVertex3f(0.0,3.0,0.0);
	glVertex3f(-3.0,1.0,0.0);
	glEnd();
	// Top square portion
	glBegin(GL_QUADS);
	glNormal3f(0.0,0.0,1.0);
	glVertex3f(-1.5,0.0,0.0);
	glVertex3f(-1.5,1.0,0.0);
	glVertex3f(-3.0,1.0,0.0);
	glVertex3f(-3.0 ,0.0,0.0);
	glEnd();
	// Bottom square portion
	glBegin(GL_QUADS);
	glNormal3f(0.0,0.0,1.0);
	glVertex3f(-1.5,-1.0,0.0);
	glVertex3f(-1.5,0.0,0.0);
	glVertex3f(-3.0,0.0,0.0);
	glVertex3f(-3.0,-1.0,0.0);
	glEnd();
	// Bottom triangle portion
	glBegin(GL_TRIANGLES);
	glNormal3f(0.0,0.0,1.0);
	glVertex3f(-1.5,-1.0,0.0);
	glVertex3f(-3.0,-1.0,0.0);
	glVertex3f(0.0,-3.0,0.0);	
	glEnd();

}

void TraverseDraw(quadricNode* somelist,int listtype,int detail)
{
	float alpha = 0.4;
	if(somelist != NULL)
	{
		// Copy list head pointer
		quadricNode* tempPointer = somelist;
		// If somelist not empty we traverse it and draw all spheres with proper textures, environment
		// maps, size, etc.
		while(tempPointer != NULL)
		{
			if((*tempPointer).texture2 != NONE)
			{
				// environment mapped
				PointVector objectPosition = (*tempPointer).objectDescription.GetPosition();
				glPushMatrix();
				glTranslatef(objectPosition.GetX(),objectPosition.GetY(),objectPosition.GetZ());
				
				glColor3f(1.0,1.0,1.0);						// Set color to white
				if((*tempPointer).hitcounter > 0)
				{
					float ratio = (float) ((*tempPointer).hitcounter) - (float) enemylife;
					//ratio = 1 - ratio;
					glColor4f(ratio,ratio,ratio,1.0);
				}
				glBindTexture(GL_TEXTURE_2D,texList[(*tempPointer).texture1]);	// bind proper texture

				gluSphere((*tempPointer).q,(*tempPointer).objectDescription.GetSize(),detail,detail);
				
				glBindTexture(GL_TEXTURE_2D,texList[(*tempPointer).texture2]);
				glColor4f(1.0,1.0,1.0,alpha);
				glEnable(GL_BLEND);
				glBlendFunc(GL_SRC_ALPHA,GL_ONE);
				glEnable(GL_TEXTURE_GEN_S);
				glEnable(GL_TEXTURE_GEN_T);
				gluSphere((*tempPointer).q,(*tempPointer).objectDescription.GetSize(),detail,detail);
				glDisable(GL_TEXTURE_GEN_S);
				glDisable(GL_TEXTURE_GEN_T);
				glDisable(GL_BLEND);
			
				glPopMatrix();
				// Move to next sphere to draw
				tempPointer = (*tempPointer).next;
			}
			else if((*tempPointer).texture2 == NONE)
			{

				// not environment mapped
				PointVector objectPosition = (*tempPointer).objectDescription.GetPosition();
				glPushMatrix();
				glTranslatef(objectPosition.GetX(),objectPosition.GetY(),objectPosition.GetZ());
				
				glColor3f(1.0,1.0,1.0);						// Set color to white
				glBindTexture(GL_TEXTURE_2D,texList[(*tempPointer).texture1]);	// bind proper texture
								if(listtype == SNOWBALLS && pushnames)
				{
					glPushName((*tempPointer).id);
				}
				gluSphere((*tempPointer).q,(*tempPointer).objectDescription.GetSize(),detail,detail);
				glPopMatrix();
				if(listtype == SNOWBALLS)
				{
					glPopName();
				}
				// Move to next sphere to draw
				tempPointer = (*tempPointer).next;	
			}
		}
	}
}

void TraverseDrawPoints(pointNode* somelist)
{
	if(somelist != NULL)
	{
		// Copy list head pointer
		pointNode* tempPointer = somelist;
		// If somelist not empty we traverse it and draw all points with proper size
		glColor4f(1.0,1.0,1.0,1.0);
		glDisable(GL_LIGHTING);
		while(tempPointer != NULL)
		{
			glBindTexture(GL_TEXTURE_2D,texList[SNOW]);	// bind snow texture so everything will be white
			PointVector pointPosition = (*tempPointer).objectDescription.GetPosition();
			float pointSize = (*tempPointer).objectDescription.GetSize();
			glPointSize(pointSize);
			glBegin(GL_POINTS);
			glVertex3f(pointPosition.GetX(),pointPosition.GetY(),pointPosition.GetZ());
			glEnd();
			tempPointer = (*tempPointer).next;
		}
		glEnable(GL_LIGHTING);
	}
}

void DrawFloor(float width,float length)							// Draws The Floor
{
	glBindTexture(GL_TEXTURE_2D, texList[ICE]);			// Select Texture 1 (0)
	glBegin(GL_QUADS);									// Begin Drawing A Quad
		glNormal3f(0.0, 1.0, 0.0);						// Normal Pointing Up
			glTexCoord2f(0.0f, 1.0f);					// Bottom Left Of Texture
			glVertex3f(-width, 0.0, length);			// Bottom Left Corner Of Floor

			glTexCoord2f(0.0f, 0.0f);					// Top Left Of Texture
			glVertex3f(-width, 0.0,-length);			// Top Left Corner Of Floor

			glTexCoord2f(1.0f, 0.0f);					// Top Right Of Texture
			glVertex3f( width, 0.0,-length);			// Top Right Corner Of Floor

			glTexCoord2f(1.0f, 1.0f);					// Bottom Right Of Texture
			glVertex3f( width, 0.0, length);			// Bottom Right Corner Of Floor
	glEnd();											// Done Drawing The Quad
}

void DrawWalls(float width,float length,float height)
{
	// all walls drawn counter clockwise when looking from the center
	// left wall
	glBindTexture(GL_TEXTURE_2D,texList[WINTER]);
	glBegin(GL_QUADS);
		glNormal3f(1.0,0.0,0.0);
			glTexCoord2f(0.0f,1.0f);		// bottom left corner of texture
			glVertex3f(-width,0.0f,length);		// bottom left corner of left wall (looking from inside world)
			
			glTexCoord2f(0.0f,0.0f);		// top left of texture
			glVertex3f(-width,height,length);	// top left of wall
			
			glTexCoord2f(1.0f,0.0f);		// top right of texture
			glVertex3f(-width,height,-length);	// top right of wall
			
			glTexCoord2f(1.0f,1.0f);		// bottom right of texture
			glVertex3f(-width,0.0f,-length);	// bottom right of wall
	glEnd();
	// right wall
	glBindTexture(GL_TEXTURE_2D,texList[WINTER]);
	glBegin(GL_QUADS);
		glNormal3f(-1.0,0.0,0.0);
			glTexCoord2f(0.0f,1.0f);		// bottom left corner of texture
			glVertex3f(width,0.0f,-length);		// bottom left corner of left wall (looking from inside world)
			
			glTexCoord2f(0.0f,0.0f);		// top left of texture
			glVertex3f(width,height,-length);	// top left of wall
			
			glTexCoord2f(1.0f,0.0f);		// top right of texture
			glVertex3f(width,height,length);	// top right of wall
			
			glTexCoord2f(1.0f,1.0f);		// bottom right of texture
			glVertex3f(width,0.0f,length);		// bottom right of wall
	glEnd();
	// +z wall
	glBindTexture(GL_TEXTURE_2D,texList[WINTER]);
	glBegin(GL_QUADS);
		glNormal3f(0.0,0.0,-1.0);
			glTexCoord2f(0.0f,1.0f);		// bottom left corner of texture
			glVertex3f(width,0.0f,length);		// bottom left corner of left wall (looking from inside world)
			
			glTexCoord2f(0.0f,0.0f);		// top left of texture
			glVertex3f(width,height,length);	// top left of wall
			
			glTexCoord2f(1.0f,0.0f);		// top right of texture
			glVertex3f(-width,height,length);	// top right of wall
			
			glTexCoord2f(1.0f,1.0f);		// bottom right of texture
			glVertex3f(-width,0.0f,length);		// bottom right of wall
	glEnd();
	// -z wall
	glBindTexture(GL_TEXTURE_2D,texList[WINTER]);
	glBegin(GL_QUADS);
		glNormal3f(0.0,0.0,1.0);
			glTexCoord2f(0.0f,1.0f);		// bottom left corner of texture
			glVertex3f(-width,0.0f,-length);	// bottom left corner of left wall (looking from inside world)
			
			glTexCoord2f(0.0f,0.0f);		// top left of texture
			glVertex3f(-width,height,-length);	// top left of wall
			
			glTexCoord2f(1.0f,0.0f);		// top right of texture
			glVertex3f(width,height,-length);	// top right of wall
			
			glTexCoord2f(1.0f,1.0f);		// bottom right of texture
			glVertex3f(width,0.0f,-length);		// bottom right of wall
	glEnd();		
}

bool BelowMaxGroundBounce(quadricNode* someNode)
{
	if((*someNode).groundcounter < maxgroundbounce)
		return true;
	else 
		return false;
}

void TraverseUpdate(quadricNode* somelist,int listtype)
{
	float elasticity = 0.0;
	if(somelist != NULL)
	{
		// Copy list head pointer
		quadricNode* tempPointer = somelist;
		// If somelist not empty we traverse it and update positions
		while(tempPointer != NULL)
		{
			if(BelowMaxGroundBounce(tempPointer))
			{
				// only update objects which have bounced less than maxgroundbounce times
				WorldObject objectToUpdate = (*tempPointer).objectDescription;	// Take out object to update
				
				if(!objectToUpdate.GroundCollision())
				{
					objectToUpdate.Accelerate(worldGravity);
				}
				else if(objectToUpdate.GroundCollision())
				{
					(*tempPointer).groundcounter = (*tempPointer).groundcounter + 1;
					if(listtype == ENEMIES)
					{
						elasticity = 0.7 ;
					}
					else if(listtype == SNOWBALLS)
					{
						elasticity = 0.5;
					}
					objectToUpdate.GroundCollisionRoutine(elasticity);
				}
				if(listtype == SNOWBALLS)
				{
					objectToUpdate = TraverseSphereCollisionRoutine(objectToUpdate,enemylist,ENEMIES,0.9);
					objectToUpdate = TraverseSphereCollisionRoutine(objectToUpdate,spherelist,SNOWBALLS,0.0001);
				}
				objectToUpdate.Move();
				(*tempPointer).objectDescription = objectToUpdate;	// Place updated object back in
			}			
			// Move to next object to update
			tempPointer = (*tempPointer).next;
		}
	}
}

WorldObject TraverseSphereCollisionRoutine(WorldObject someobject,quadricNode* somelist,int listtype,float elasticity)
{
	while(somelist != NULL)
	{
		// extract objectDescription from each node in the list then compare each one 
		// for sphere collision
		WorldObject extractedObject = (*somelist).objectDescription;
		if(someobject.SphereCollision(extractedObject))
		{
			if(listtype == ENEMIES)
			{
				(*somelist).hitcounter = (*somelist).hitcounter + 1;	// increment hit counter if its an enemy
				int scorecount = maxgroundbounce - (*somelist).groundcounter;
				printf("Score for this hit is: %d\n",scorecount);
				score += scorecount;
				printf("Total score is: %d\n",score);
			}
			someobject.SphereCollisionRoutine(extractedObject,elasticity);
		}
		somelist = (*somelist).next;	// move to next node and do the same
	}
	return someobject;
}

bool EnemyIsDead(quadricNode* somelist)
{	
	if((*somelist).hitcounter >= enemylife)
	{
		return true;
	}
	return false;
}

void TraverseUpdatePoints(pointNode* somelist)
{
	if(somelist != NULL)
	{
		// Copy list head pointer
		pointNode* tempPointer = somelist;
		// If somelist not empty we traverse it and update positions
		while(tempPointer != NULL)
		{
			if(!((*tempPointer).objectDescription).BelowGround())
			{
				// only update objects which are above ground level
				WorldObject objectToUpdate = (*tempPointer).objectDescription;	// Take out object to update
				objectToUpdate.Accelerate(snowGravity);
				objectToUpdate.Move();
				(*tempPointer).objectDescription = objectToUpdate;	// Place updated object back in
			}			
			// Move to next object to update
			tempPointer = (*tempPointer).next;
		}
	}
}

quadricNode* TraverseRemove(quadricNode* somelist,int listtype)
{
	if(somelist != NULL)
	{
		// Copy list head pointer
		quadricNode* currentPointer = somelist;				// current node
		quadricNode* prevPointer = NULL;				// previous node
		WorldObject currentObject = (*currentPointer).objectDescription;// extract object description
		
		if(removeAll || ObjectOutOfBounds(currentObject) || EnemyIsDead(currentPointer) || (listtype == SNOWBALLS && (*currentPointer).id == snowballpicked))
		{
			// If first item is to be deleted, delete then update somelist head
			prevPointer = (*currentPointer).next;
			delete currentPointer;
			currentPointer = prevPointer;
			somelist = currentPointer;
			prevPointer = NULL;
			snowballcounter--;
		}
		else
		{
			prevPointer = currentPointer;
			currentPointer = (*currentPointer).next;
		}
		while(currentPointer != NULL)	// as long as we aren't at the end of the list
		{	
			currentObject = (*currentPointer).objectDescription;	// extract object description
			// If somelist not empty we traverse it and remove objects which are:
			// 1: out of bounds
			if(removeAll || ObjectOutOfBounds(currentObject) || EnemyIsDead(currentPointer) || (listtype == SNOWBALLS && (*currentPointer).id == snowballpicked))
			{	
				// Remove object from somelist
				// If first object to be deleted, delete then update somelist head
				if(currentPointer == somelist)
				{
					prevPointer = (*currentPointer).next;
					delete currentPointer;
					currentPointer = prevPointer;
					somelist = currentPointer;
					prevPointer = NULL;
				}
				// If middle or last object, set prev's next to temp's next then delete temp
				else if(prevPointer != NULL)
				{
					(*prevPointer).next = (*currentPointer).next;
					delete currentPointer;
					currentPointer = (*prevPointer).next;
				}
				snowballcounter--;
			}
			else
			{
				prevPointer = currentPointer;
				currentPointer = (*currentPointer).next;
			}
		}
	}
	return somelist;
}

pointNode* TraverseRemovePoints(pointNode* somelist)
{
	if(somelist != NULL)
	{
		// Copy list head pointer
		pointNode* currentPointer = somelist;				// current node
		pointNode* prevPointer = NULL;				// previous node
		WorldObject currentObject = (*currentPointer).objectDescription;// extract object description
		
		if(currentObject.BelowGround())
		{
			// If first item is to be deleted, delete then update somelist head
			prevPointer = (*currentPointer).next;
			delete currentPointer;
			currentPointer = prevPointer;
			somelist = currentPointer;
			prevPointer = NULL;
			snowcounter--;
		}
		else
		{
			prevPointer = currentPointer;
			currentPointer = (*currentPointer).next;
		}
		while(currentPointer != NULL)	// as long as we aren't at the end of the list
		{	
			currentObject = (*currentPointer).objectDescription;	// extract object description
			// If somelist not empty we traverse it and remove objects which are:
			// 1: below ground
			if(currentObject.BelowGround())
			{	
				// Remove object from somelist
				// If first object to be deleted, delete then update somelist head
				if(currentPointer == somelist)
				{
					prevPointer = (*currentPointer).next;
					delete currentPointer;
					currentPointer = prevPointer;
					somelist = currentPointer;
					prevPointer = NULL;
				}
				// If middle or last object, set prev's next to temp's next then delete temp
				else if(prevPointer != NULL)
				{
					(*prevPointer).next = (*currentPointer).next;
					delete currentPointer;
					currentPointer = (*prevPointer).next;
				}
			}
			else
			{
				prevPointer = currentPointer;
				currentPointer = (*currentPointer).next;
			}
		}
	}
	return somelist;
}

void DrawWorldBox(float width,float length,float height,bool wireframe)
{
	float newwidth = width / 2.0;
	float newheight = height / 2.0;
	float newlength = length / 2.0;
	float negwidth = -newwidth;
	float negheight = -newheight;
	float neglength = -newlength;
	if(wireframe)
	{
		glutWireCube(width);
	}
	else
	{
	// looking down -z axis
	// first draw right face
	glBegin(GL_QUADS);
	glVertex3f(newwidth,negheight,neglength);
	glVertex3f(newwidth,negheight,newlength);
	glVertex3f(newwidth,newheight,newlength);
	glVertex3f(newwidth,newheight,neglength);
	glEnd();
	// next draw left face
	glBegin(GL_QUADS);
	glVertex3f(negwidth,negheight,neglength);
	glVertex3f(negwidth,negheight,newlength);
	glVertex3f(negwidth,newheight,newlength);
	glVertex3f(negwidth,newheight,newlength);
	glEnd();
	// next draw front face
	glBegin(GL_QUADS);
	glVertex3f(negwidth,negheight,newlength);
	glVertex3f(newwidth,negheight,newlength);
	glVertex3f(newwidth,newheight,newlength);
	glVertex3f(negwidth,newheight,newlength);
	glEnd();
	// next draw back face
	glBegin(GL_QUADS);
	glVertex3f(negwidth,negheight,neglength);
	glVertex3f(newwidth,negheight,neglength);
	glVertex3f(newwidth,newheight,neglength);
	glVertex3f(negwidth,newheight,neglength);
	glEnd();
	// next draw bottom face
	glBegin(GL_QUADS);
	glVertex3f(negwidth,negheight,neglength);
	glVertex3f(newwidth,negheight,neglength);
	glVertex3f(newwidth,negheight,newlength);
	glVertex3f(negwidth,negheight,newlength);
	glEnd();
	// finally draw top face
	glBegin(GL_QUADS);
	glVertex3f(negwidth,newheight,neglength);
	glVertex3f(newwidth,newheight,neglength);
	glVertex3f(newwidth,newheight,newlength);
	glVertex3f(negwidth,newheight,newlength);
	glEnd();
	}
}

void RotateCameraPitch(GLfloat* pitchRotation)
{
	// rotate cameraUp and cameraView vectors around the arbitrary X (pitch) axis
	cameraUpVector.MultiplyMatrix(pitchRotation);
	cameraUpVector.Normalize();
	cameraViewVector.MultiplyMatrix(pitchRotation);
	cameraViewVector.Normalize();
}

void RotateCameraRoll(GLfloat* rollRotation)
{
	// rotate cameraUp vector around arbitrary Z (roll) axis
	cameraUpVector.MultiplyMatrix(rollRotation);
	cameraUpVector.Normalize();
}

void RotateCameraYaw(GLfloat* yawRotation)
{
	// rotate cameraView around the Y (yaw, Up) axis
	// only changes cameraViewVector
	cameraViewVector.MultiplyMatrix(yawRotation);  
	cameraViewVector.Normalize();
}

void MoveCamera(float speed)
{
	float border = 1.0;
	float moveX;
	float moveY;
	float moveZ;
	if(cameraMode == FREEFLYMODE)
	{
		moveX = cameraViewVector.GetX() * speed;
		moveY = cameraViewVector.GetY() * speed;
		moveZ = cameraViewVector.GetZ() * speed;
		if(cameraStop)
		{
			if(moveX + cameraPosition.GetX() < -worldwidth + border)
			{
				moveX = 0;
			}
			if(moveX + cameraPosition.GetX()> worldwidth - border)
			{
				moveX = 0;
			}
			if(moveZ + cameraPosition.GetZ() < -worldlength + border)
			{
				moveZ = 0;
			}
			if(moveZ + cameraPosition.GetZ() > worldlength - border)
			{
				moveZ = 0;
			}
			if(moveY + cameraPosition.GetY() < 0.0 + border)
			{
				moveY = 0;
			}
			if(moveY + cameraPosition.GetY() > worldheight - border)
			{
				moveY = 0;
			}
		}
	}
	else if(cameraMode == PLAYERMODE)
	{
		PointVector projectedXZ = cameraViewVector.ProjectToXZ();
		moveX = projectedXZ.GetX() * speed;
		moveY = projectedXZ.GetY() * speed;
		moveZ = projectedXZ.GetZ() * speed;
		if(cameraStop)
		{
			if(moveX + cameraPosition.GetX() < -worldwidth + border)
			{
				moveX = 0;
			}
			if(moveX + cameraPosition.GetX()> worldwidth - border)
			{
				moveX = 0;
			}
			if(moveZ + cameraPosition.GetZ() < -worldlength + border)
			{
				moveZ = 0;
			}
			if(moveZ + cameraPosition.GetZ() > worldlength - border)
			{
				moveZ = 0;
			}
			if(moveY + cameraPosition.GetY() < 0.0 + border)
			{
				moveY = 0;
			}
			if(moveY + cameraPosition.GetY() > worldheight - border)
			{
				moveY = 0;
			}
		}
	}
		
	// move camera position
	moveX += cameraPosition.GetX();
	moveY += cameraPosition.GetY();
	moveZ += cameraPosition.GetZ();
	cameraPosition.SetX(moveX);
	cameraPosition.SetY(moveY);
	cameraPosition.SetZ(moveZ);
}

void Mouse(int button,int state,int x,int y)
{
	if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN && !mouseCoords.leftMouseDown)
	{
		// if clicked, get current coordinates
		// then in motion func just subtract new from current
		mouseCoords.x = x;
		mouseCoords.y = y;
		mouseCoords.leftMouseDown = true;
		mouseCoords.rollPressed = true;
		mouseCoords.movePressed = true;
		mouseCoords.moved = true;
	}
	if(button == GLUT_LEFT_BUTTON && state == GLUT_UP && mouseCoords.leftMouseDown)
	{
		mouseCoords.leftMouseDown = false;
		mouseCoords.rollPressed = false;
		mouseCoords.movePressed = false;
		mouseCoords.moved = true;
    }
	if(button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN && !mouseCoords.rightMouseDown)
    {
	    mouseCoords.x = x;
		mouseCoords.y = y;
		mouseCoords.rightMouseDown = true;
		mouseCoords.pitchPressed = true;
		mouseCoords.yawPressed = true;
		mouseCoords.moved = true;
    }
	if(button == GLUT_RIGHT_BUTTON && state == GLUT_UP && mouseCoords.rightMouseDown)
    {
		mouseCoords.rightMouseDown = false;
		mouseCoords.pitchPressed = false;
		mouseCoords.yawPressed = false;
		mouseCoords.moved = true;
	}
}

void ThrowSnowBall()
{
	// Only generate new snowball if maxsnowballcount isn't reached
	if(snowballcounter < maxsnowballcount)
	{
		///printf("maxsnowballcount: %d\n",maxsnowballcount);
		score -= 2;
		printf("Score is: %d\n",score);
		// New snowball world object created at cameraPosition, initially accelerated in direction of cameraViewVector
		WorldObject snowballObject = WorldObject(cameraPosition.Add(cameraViewVector),snowballmass,snowballsize);
		// snowball accelerated in direction of cameraViewVector and multiplied by throwing strength
		PointVector scaledCameraView = cameraViewVector;
		scaledCameraView.Normalize();
		scaledCameraView.MultiplyScalar(throwstrength);
		snowballObject.Accelerate(scaledCameraView);
		// finally now add to sphere list
		snowballidcounter++;
		spherelist = AddToQuadricList(spherelist,SNOWBALLS,snowballObject,SNOW,NONE);
		snowballcounter++;
	}
}

quadricNode* AddToQuadricList(quadricNode* somelist,int listtype,WorldObject object,int tex1,int tex2)
{
	// First initialize quadricNode
	quadricNode* newquadricNode = new quadricNode;
	(*newquadricNode).objectDescription = object;
	(*newquadricNode).q = gluNewQuadric();			// Create a new quadratic
	gluQuadricNormals((*newquadricNode).q,GL_SMOOTH);	// Generate smooth normals for the quadratic
	gluQuadricTexture((*newquadricNode).q,GL_TRUE);		// Enable texture coords for the quadratic
	(*newquadricNode).next = NULL;				// next node in list
	(*newquadricNode).groundcounter = 0;			// how many times bounced off the ground
	(*newquadricNode).texture1 = tex1;			// base texture
	(*newquadricNode).texture2 = tex2;			// environment map texture
	(*newquadricNode).hitcounter = 0;		// if its an enemy sphere object we initialize its hit counter
	(*newquadricNode).id = snowballidcounter;

	// Insert to some quadric list
	if(somelist == NULL)
	{
		somelist = newquadricNode;	// List is empty insert to front
		return somelist;		// Return new list head since its updated
	}
	else if(somelist != NULL)
	{
		// List not empty, copy somelist pointer then traverse to the end, finally add to end of somelist
		quadricNode* tempNode = somelist;
		while((*tempNode).next != NULL)
		{
			tempNode = (*tempNode).next;
		}
		(*tempNode).next = newquadricNode;
		return somelist;
	}
}

pointNode* AddToPointList(pointNode* somelist,WorldObject object)
{
	// First initialize pointNode
	pointNode* newpointNode = new pointNode;
	(*newpointNode).objectDescription = object;
	(*newpointNode).next = NULL;

	// Insert to some node list
	if(somelist == NULL)
	{
		somelist = newpointNode;	// List is empty insert to front
		return somelist;		// Return new list head since its updated
	}
	else if(somelist != NULL)
	{
		// List not empty, copy somelist pointer then traverse to the end, finally add to end of somelist
		pointNode* tempNode = somelist;
		while((*tempNode).next != NULL)
		{
			tempNode = (*tempNode).next;
		}
		(*tempNode).next = newpointNode;
		return somelist;
	}
	return somelist;
}

void NormalKeys(unsigned char key, int x, int y) 
{
	switch (key)
	{
	case '1':
	removeAll = true;
	spherelist = TraverseRemove(spherelist,SNOWBALLS);
	enemylist = TraverseRemove(enemylist,ENEMIES);
	removeAll = false;
	InitWorldData(1);
	GenerateRandomEnemies(numberenemies);
	printf("**********Level 1**********\n");
	break;
		case '2':
	removeAll = true;
	spherelist = TraverseRemove(spherelist,SNOWBALLS);
	enemylist = TraverseRemove(enemylist,ENEMIES);
	removeAll = false;
	InitWorldData(2);
	GenerateRandomEnemies(numberenemies);
	printf("**********Level 2**********\n");
	break;
		case '3':
	removeAll = true;
	spherelist = TraverseRemove(spherelist,SNOWBALLS);
	enemylist = TraverseRemove(enemylist,ENEMIES);
	removeAll = false;
	InitWorldData(3);
	GenerateRandomEnemies(numberenemies);
	printf("**********Level 3**********\n");
	break;
		case '4':
	removeAll = true;
	spherelist = TraverseRemove(spherelist,SNOWBALLS);
	enemylist = TraverseRemove(enemylist,ENEMIES);
	removeAll = false;
	InitWorldData(4);
	GenerateRandomEnemies(numberenemies);
	printf("**********Level 4**********\n");
	break;
		case '5':
	removeAll = true;
	spherelist = TraverseRemove(spherelist,SNOWBALLS);
	enemylist = TraverseRemove(enemylist,ENEMIES);
	removeAll = false;
	InitWorldData(5);
	GenerateRandomEnemies(numberenemies);
	printf("**********Level 5**********\n");
	break;
		case '6':
	removeAll = true;
	spherelist = TraverseRemove(spherelist,SNOWBALLS);
	enemylist = TraverseRemove(enemylist,ENEMIES);
	removeAll = false;
	InitWorldData(6);
	GenerateRandomEnemies(numberenemies);
	printf("**********Level 6**********\n");
	break;
		case '7':
	removeAll = true;
	spherelist = TraverseRemove(spherelist,SNOWBALLS);
	enemylist = TraverseRemove(enemylist,ENEMIES);
	removeAll = false;
	InitWorldData(7);
	GenerateRandomEnemies(numberenemies);
	printf("**********Level 7**********\n");
	break;
		case '8':
	removeAll = true;
	spherelist = TraverseRemove(spherelist,SNOWBALLS);
	enemylist = TraverseRemove(enemylist,ENEMIES);
	removeAll = false;
	InitWorldData(8);
	GenerateRandomEnemies(numberenemies);
	printf("**********Level 8**********\n");
	break;
		case '9':
	removeAll = true;
	spherelist = TraverseRemove(spherelist,SNOWBALLS);
	enemylist = TraverseRemove(enemylist,ENEMIES);
	removeAll = false;
	InitWorldData(9);
	GenerateRandomEnemies(numberenemies);
	printf("**********Level 9**********\n");
	break;
		case '0':
	removeAll = true;
	spherelist = TraverseRemove(spherelist,SNOWBALLS);
	enemylist = TraverseRemove(enemylist,ENEMIES);
	removeAll = false;
	InitWorldData(15);
	GenerateRandomEnemies(numberenemies);
	printf("**********Level 10**********\n");
	break;
	case 'r':
	InitWorldData(1);
	removeAll = true;
	spherelist = TraverseRemove(spherelist,SNOWBALLS);
	enemylist = TraverseRemove(enemylist,ENEMIES);
	removeAll = false;
	break;
	case 'q':
		DestroyData();
		exit(0);
	break;
	case 'e':
		GenerateRandomEnemies(numberenemies);
		break;
	case ' ':
	ThrowSnowBall();
	if(maxsnowballcount - snowballcounter == 0)
	{
		printf("No snowballs left, please pick them up off the ground using 'l' key,\nor wait for out of bounds snowballs to return\n");
	}
	else
	{
		printf("There are %d snowballs left\n",maxsnowballcount - snowballcounter);
	}

	// fire snowball in view vector direction
	break;
	case 'c':
	if(cameraMode == FREEFLYMODE)
	{
		cameraMode = PLAYERMODE;
		InitCameraData();
	}
	else
	{
		cameraMode = FREEFLYMODE;
		InitCameraData();
	}
	break;
	case 'm':
		snowmelt = !snowmelt;
		break;
	case 'f':
		fpstoggle = !fpstoggle;
		break;
	case 'l':
		mouseCursorX = x;
		mouseCursorY = y;
		mode = SELECT;
		break;
	case 's':
		cameraStop = !cameraStop;
		break;
	case '+':
		throwstrength += 0.1;
		if(throwstrength > 4.0)
			throwstrength = 4.0;
		break;
	case '-':
		throwstrength -= 0.1;
		if(throwstrength < 0.4)
			throwstrength = 0.4;
		break;
	}
}

void ProcessHits(GLint hits, GLuint buffer[], int sw)
{
   GLint i, j, numberOfNames;
   GLuint names, *ptr, minZ,*ptrNames;

   ptr = (GLuint *) buffer;
   minZ = 0xffffffff;
   for (i = 0; i < hits; i++) {	
      names = *ptr;
	  ptr++;
	  if (*ptr < minZ) {
		  numberOfNames = names;
		  minZ = *ptr;
		  ptrNames = ptr+2;
	  }
	  ptr += names+2;
	}
   if (numberOfNames > 0) {
//	  printf ("You picked sphere  ");
	  ptr = ptrNames;
	  for (j = 0; j < numberOfNames; j++,ptr++) { 
//		 printf ("%d ", *ptr);
		 //cubeFace[j] = *ptr;
		 snowballpicked = *ptr;
	  }
	}

//	   printf("You didn't click a sphere!");
//  printf ("\n");

   
}

void RenderScene(void) 
{
	SnowRoutine();
	PositionCamera();				// Set camera orientation
	glBindTexture(GL_TEXTURE_2D,texList[SNOW]);	// bind snow texture so everything will be white
	DrawText();

	DrawWalls(worldwidth,worldlength,worldheight);	// Draw the walls of the world
	DrawReflectionObjects();			// Draw objects that reflect (floor) and ones that get reflected
	
	// Draw axis
	glBegin(GL_LINES);
	glColor3f(1.0,1.0,1.0); 
	// first draw horizontal x axis
	glVertex3f(0.0,0.0,0.0);
	glVertex3f(50.0,0.0,0.0);
	glEnd();
	glBegin(GL_LINES);
	glColor3f(1.0,1.0,1.0);
	// next draw vertical y axis
	glVertex3f(0.0,50.0,0.0);
	glVertex3f(0.0,0.0,0.0);
	glEnd();
	glBegin(GL_LINES);
	glColor3f(1.0,1.0,1.0);
	// lastly draw z axis
	glVertex3f(0.0,0.0,50.0);
	glVertex3f(0.0,0.0,0.0);
	glEnd();

	TraverseUpdate(spherelist,SNOWBALLS);
	TraverseUpdate(enemylist,ENEMIES);
	TraverseUpdatePoints(snowlist);
	
	spherelist = TraverseRemove(spherelist,SNOWBALLS);
	enemylist = TraverseRemove(enemylist,ENEMIES);
	if(snowmelt)
	{
		snowlist = TraverseRemovePoints(snowlist);
	}
	glPushMatrix();
	glTranslatef(worldwidth / 2.0,worldheight * 1.1,0.0);
	DrawMoon();
	glPopMatrix();

	if(mode == SELECT)
		StopPicking();

	/*if(fpstoggle)
		UpdateFps();*/

	glFlush();					
	glutSwapBuffers();
}

void DrawText()
{
	// Draw Crosshair
	glDisable(GL_LIGHTING);
	glColor4f(0.0,0.91,0.37,1.0);
	PointVector rasterPosition = cameraPosition.Add(cameraViewVector);
	RenderBitmapCharacter(rasterPosition.GetX(),rasterPosition.GetY(),rasterPosition.GetZ(),"X");

//	RenderBitmapCharacter(rasterPosition.GetX(),rasterPosition.GetY() - 0.1,rasterPosition.GetZ(),(char) *str);
	glEnable(GL_LIGHTING);
}

unsigned char* loadPNM( const char *filename,
     unsigned int& newwidth, unsigned int &newheight,
     unsigned int &numComponents )
{
  FILE          *imgFile;
  char          buf[1024];
  char          type;
  int           i, j, k, l;
  unsigned char    *imageData;

  imgFile= fopen( filename, "rb" );
  if( errno!= 0 )
    return NULL;
  // read PNM magic number (P1 to P6)
  if( fscanf( imgFile, "P%c \n", &type )!= 1 || type< '1' || type> '8')
  {
    fclose( imgFile );
    return NULL;
  }
  // skip comments
  while( fscanf( imgFile, "#%[^\n]\n", buf ) )
    ;
  // read newwidth
  fscanf( imgFile, "%d", &newwidth );
  /* skip comments */
  while( fscanf( imgFile, "#%[^\n]\n", buf ) )
    ;
  /* read newheight */
  fscanf( imgFile, "%d", &newheight );
  /* skip comments */
  while( fscanf( imgFile, "#%[^\n]\n", buf ) )
    ;
  /* skip max. component and exactly one whitespace */
  fscanf( imgFile, "%*d%*c" );

  switch( type )
  {
  case '1': // ASCII bitmap
  case '4': // binary bitmap
    std::cerr << "Bitmaps not implemented\n";
    fclose( imgFile );
    return NULL;
  case '2': // ASCII greymap
    imageData= new unsigned char[newwidth*newheight];
    for( i= 0 ; i< newheight ; i++ )
      for( j= 0 ; j< newwidth ; j++ )
      {
    fscanf( imgFile, "%d", &l );
    imageData[i*newwidth+j]= l;
      }
    numComponents= 1;
    break;
  case '3': // ASCII RGB
    imageData= new unsigned char[newwidth*newheight*3];
    for( i= 0 ; i< newheight ; i++ )
      for( j= 0 ; j< newwidth ; j++ )
    for( k= 0 ; k< 3 ; k++ )
    {
      fscanf( imgFile, "%d", &l );
      imageData[(i*newwidth+j)*3+k]= l;
    }
    numComponents= 3;
    break;
  case '5': // binary greymap
    imageData= new unsigned char[newwidth*newheight];
    fread( imageData, 1, newwidth*newheight, imgFile );
    numComponents= 1;
    break;
  case '6': // binary RGB
    imageData= new unsigned char[newwidth*newheight*3];
    fread( imageData, 1, newwidth*newheight*3, imgFile );
    numComponents= 3;
    break;
  }
  fclose( imgFile );

  return imageData;
} 

void RenderBitmapCharacter(float x,float y,float z,char *string)
{ 
  char *c;
  glRasterPos3f(x,y,z);
  for (c=string; *c != '\0'; c++) {
    glutBitmapCharacter(GLUT_BITMAP_9_BY_15, *c);
  }
}
